@echo off

setlocal

set JDBC_JAR=
set JMX_PORT=3099

set BUNDLED_JAVA_HOME=
if not "%BUNDLED_JAVA_HOME%" == "" set JAVA_HOME=%BUNDLED_JAVA_HOME%

if ""%1"" == ""start""    goto doStart
if ""%1"" == ""status""   goto doStatus
if ""%1"" == ""stop""     goto doStop
if ""%1"" == ""console""  goto doConsole

echo Usage:  pimlistener ( commands ... )
echo commands:
echo   start           Start PimListener
echo   start -debug    Start PimListener with output console
echo   stop            Stop  PimListener
echo   console         Start PimListener command line console
echo   status          Show  PimListener status
goto END

:doStart
if ""%2"" == ""-debug"" (
    set EXEC=start "Pim Listener" "%JAVA_HOME%\bin\java.exe"
) else (
    set EXEC=start "Pim Listener" "%JAVA_HOME%\bin\javaw.exe"
)

set CLASS_NAME=com.funambol.pushlistener.service.PushListener
set JAVA_OPTS=%JAVA_OPTS% -Dcom.sun.management.jmxremote -Dcom.sun.management.jmxremote.port=%JMX_PORT% -Dcom.sun.management.jmxremote.ssl=false -Dcom.sun.management.jmxremote.authenticate=false

rem Uncomment the following line to enable remote debug
rem set JAVA_OPTS=%JAVA_OPTS% -Xdebug -Xrunjdwp:transport=dt_socket,address=7777,server=y,suspend=n

goto CONT1

:doStop
set EXEC="%JAVA_HOME%\bin\java.exe"
set CLASS_NAME=com.funambol.pushlistener.service.ManagementTools
set ARGS=localhost %JMX_PORT% stop
goto CONT1

:doStatus
set EXEC="%JAVA_HOME%\bin\java.exe"
set CLASS_NAME=com.funambol.pushlistener.service.ManagementTools
set ARGS=localhost %JMX_PORT% status
goto CONT1

:doConsole
set EXEC="%JAVA_HOME%\bin\java.exe"
set CLASS_NAME=com.funambol.pimlistener.console.Menu
goto CONT1

:CONT1
if not "%JAVA_HOME%" == "" goto CONT2
echo ERROR: Please, set JAVA_HOME before running this script.
goto END
:CONT2

set CURRENT_DIR=%cd%
set PIM_LISTENER_HOME=%CURRENT_DIR%
if exist "%PIM_LISTENER_HOME%\bin\pimlistener.cmd" goto okHome
cd ..
set PIM_LISTENER_HOME=%cd%

:okHome
if "JDBC_JAR" == "" goto okJDBC
set ORIGINAL_JDBC_JAR=%JDBC_JAR%
if not exist "%JDBC_JAR%" set JDBC_JAR=%PIM_LISTENER_HOME%\lib\%JDBC_JAR%
if not exist "%JDBC_JAR%" set JDBC_JAR=%ORIGINAL_JDBC_JAR%

:okJDBC
set LIBDIR=%PIM_LISTENER_HOME%\lib

set CLASSPATH=%JDBC_JAR%
set CLASSPATH=%CLASSPATH%;%LIBDIR%\commons-collections-3.2.jar
set CLASSPATH=%CLASSPATH%;%LIBDIR%\commons-dbcp-1.2.1.jar
set CLASSPATH=%CLASSPATH%;%LIBDIR%\commons-lang-2.2.jar
set CLASSPATH=%CLASSPATH%;%LIBDIR%\commons-pool-1.3.jar
set CLASSPATH=%CLASSPATH%;%LIBDIR%\log4j-1.2.14.jar
set CLASSPATH=%CLASSPATH%;%LIBDIR%\axis.jar
set CLASSPATH=%CLASSPATH%;%LIBDIR%\jaxrpc.jar
set CLASSPATH=%CLASSPATH%;%LIBDIR%\wsdl4j-1.5.1.jar
set CLASSPATH=%CLASSPATH%;%LIBDIR%\commons-logging-1.1.jar
set CLASSPATH=%CLASSPATH%;%LIBDIR%\commons-discovery-0.4.jar
set CLASSPATH=%CLASSPATH%;%LIBDIR%\saaj.jar

set CLASSPATH=%CLASSPATH%;%LIBDIR%\funambol-push-listener-6.0.3.jar
set CLASSPATH=%CLASSPATH%;%LIBDIR%\funambol-pim-listener-6.0.3.jar
set CLASSPATH=%CLASSPATH%;%LIBDIR%\funambol-framework.jar
set CLASSPATH=%CLASSPATH%;%LIBDIR%\funambol-server.jar
set CLASSPATH=%CLASSPATH%;%LIBDIR%\funambol-ext-6.0.2.jar

set JAVA_OPTS=%JAVA_OPTS% -Dfunambol.pushlistener.home="%PIM_LISTENER_HOME%"

echo CLASSPATH: "%CLASSPATH%"
echo JAVA_OPTS: %JAVA_OPTS%
%EXEC% %JAVA_OPTS% -classpath "%CLASSPATH%" %CLASS_NAME% %ARGS%

cd %CURRENT_DIR%

:END
endlocal

